c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c      
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c     
      subroutine analytic_budgets(k,nbw,pne_in,coeff,
     &     psi,psi_gg,psi_gp,psi_gs,psi_ge,psih,psib)
      implicit none
      
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'

      integer i,j,k,l
      double precision nbw,tmp1,coeff
      double precision pne(0:Nmax+1,0:Nmax+1)
      double precision pne_in(0:Nmax+1,0:Nmax+1)

      double precision psi(0:Nmax+1,1:Kmax)
      double precision psih(0:Nmax+1,1:Kmax)
      double precision psib(0:Nmax+1,1:Kmax)
      double precision psi_gg(0:Nmax+1,1:Kmax)
      double precision psi_gp(0:Nmax+1,1:Kmax)
      double precision psi_gs(0:Nmax+1,1:Kmax)
      double precision psi_ge(0:Nmax+1,1:Kmax)

c     Debug
c      if (k.eq.1) then
c         do i=0,m+1
c            do j=0,m+1
c               write(*,*) 'PNE(',i,',',j,')=',pne(i,j)
c            enddo ! j
c         enddo ! i
c         stop
c      endif
c     Debug

      do i=0,m+1
         do j=0,m+1
            pne(i,j)=pne_in(i,j)*coeff
         enddo ! j
      enddo ! j

c     Calcul du bilan de la maille i
      do i=0,m+1
         psi(i,k)=0.0D+0
         psi_gg(i,k)=0.0D+0
         psi_gp(i,k)=0.0D+0
         psi_gs(i,k)=0.0D+0
         psi_ge(i,k)=0.0D+0
         psih(i,k)=0.0D+0
         psib(i,k)=0.0D+0
         
         do l=0,m+1
            psi(i,k)=psi(i,k)+PNE(i,l)
            if ((l.eq.0).or.(l.eq.m+1)) then
               psi_gp(i,k)=psi_gp(i,k)+PNE(i,l)
               if (l.eq.0) then
                  psi_gs(i,k)=psi_gs(i,k)+PNE(i,l)
               else
                  psi_ge(i,k)=psi_ge(i,k)+PNE(i,l)
               endif
            else
               psi_gg(i,k)=psi_gg(i,k)+PNE(i,l)
            endif
            if (l.le.i) then
               psib(i,k)=psib(i,k)+PNE(i,l)
c     Debug
c               if (i.eq.40) then
c                  write(*,*) 'PNE(',i,',',l,')=',PNE(i,l)
c               endif
c     Debug
            else
               psih(i,k)=psih(i,k)+PNE(i,l)
            endif
         enddo                  ! sur l
c     Debug
c         if (i.eq.40) then
c            write(*,*) 'psib(',i,',',k,')=',psib(i,k)
c            stop
c         endif
c     Debug
         
c     Actuellement : normalisation par la largeur des bandes troites
         if ((i.eq.0).or.(i.eq.m+1)) then
            tmp1=nbw
c     tmp1=1.0D+0
         else
            tmp1=(e(i)-e(i-1))*nbw
c     tmp1=(e(i)-e(i-1))
         endif
         
c     Debug
c         if (i.eq.1) then
c            write(*,*) 'psib(1,',k,')=',psib(1,k),' tmp1=',tmp1
c         endif
c     Debug
         psi(i,k)=psi(i,k)/tmp1 ! W/m/cm
         psi_gg(i,k)=psi_gg(i,k)/tmp1 ! W/m/cm
         psi_gp(i,k)=psi_gp(i,k)/tmp1 ! W/m/cm
         psi_gs(i,k)=psi_gs(i,k)/tmp1 ! W/m/cm
         psi_ge(i,k)=psi_ge(i,k)/tmp1 ! W/m/cm
         psih(i,k)=psih(i,k)/tmp1
         psib(i,k)=psib(i,k)/tmp1
      enddo                     ! sur i

c     Debug
c      write(*,*)
c      write(*,*) 'k=',k
c      do i=0,m+1
c         write(*,*) i,psi(i,k)
c      enddo
c     Debug

      return
      end
