c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine calc_T(T)
      implicit none
      include 'max.inc'
      include 'data.inc'
c      double precision Tmoy(0:Nmax+1)
      double precision T(0:Nmax)
      integer i,j

c     Purpose: to compute Tmoy(i) the mean temperature in layer i.
c     i=0 is for the ground
c     i=1,m is for gas layers
c     i=m+1 is for space

c      Tmoy(0)=Tsol ! ground temperature      
c      T(1)=temp(0)+(temp(1)-temp(0))/(alt(1)-alt(0))*
c     &     (e(1)-alt(0)) ! T(z=e(1))
c      Tmoy(1)=(T(1)+temp(0))/2.0D+0 ! <T(1)>

      T(0)=Tsol                 ! ground temperature (maille 0)
      T(1)=temp(0)+(temp(1)-temp(0))/(alt(1)-alt(0))*
     &     ((e(0)+e(1))/2.0D+0-alt(0)) ! Tcentre maille 1

      do i=2,m-1
c         do j=0,m-1
c            if ((alt(j).ge.e(i-1)).and.(alt(j).le.e(i))) then
c               goto 123
c            endif
c         enddo                  ! j
c 123     continue
cc     Now e(i-1) < alt(j) < e(i+1)

c         T(i)=temp(j)+(temp(j+1)-temp(j))/(alt(j+1)-alt(j))*
c     &        (e(i)-alt(j)) ! T(z=e(i))
c         Tmoy(i)=(T(i)+temp(j))/2.0D+0*(e(i)-alt(j))/(e(i)-e(i-1))+
c     &        (temp(j)+T(i-1))/2.0D+0*(alt(j)-e(i-1))/(e(i)-e(i-1)) ! <T(i)>
         T(i)=temp(i-1)         ! Tcentre maille i
      enddo

c      Tmoy(m)=(temp(m-2)+T(m-1))/2.0D+0*(alt(m-2)-e(m-1))/(e(m)-e(m-1))+
c     &     (temp(m-1)+temp(m-2))/2.0D+0*(e(m)-alt(m-2))/(e(m)-e(m-1)) ! <T(m)>
c      Tmoy(m+1)=Tesp ! temperature of space
      T(m)=temp(m-2)+(temp(m-1)-temp(m-2))/(alt(m-1)-alt(m-2))*
     &     ((e(m)+e(m-1))/2.0D+0-alt(m-2)) ! Tcentre maille m
      T(m+1)=Tesp ! temperature of space

      return
      end




      subroutine calc_rT(mr,rT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer mr
      double precision rT(0:Nmax)
      integer i,j

c     Purpose: to compute Tmoy(i) the mean temperature in layer i for recombined grid.
c     i=0 is for the ground
c     i=1,m is for gas layers
c     i=m+1 is for space


      rT(0)=Tsol                 ! ground temperature (maille 0)
      if (alt(1).gt.(er(0)+er(1))/2.0D+0) then
         rT(1)=temp(0)+(temp(1)-temp(0))/(alt(1)-alt(0))*
     &        ((er(0)+er(1))/2.0D+0-alt(0))
      else
         rT(1)=temp(1)+(temp(2)-temp(1))/(alt(2)-alt(1))*
     &        ((er(0)+er(1))/2.0D+0-alt(1))
      endif
      do i=2,m-1
         rT(i)=temp(i)
      enddo
      if (alt(m-2).gt.(er(mr)+er(mr-1))/2.0D+0) then
         rT(mr)=temp(m-3)+(temp(m-2)-temp(m-3))/(alt(m-2)-alt(m-3))*
     &        ((er(mr)+er(mr-1))/2.0D+0-alt(m-3))
      else
         rT(mr)=temp(m-2)+(temp(m-1)-temp(m-2))/(alt(m-1)-alt(m-2))*
     &        (alt(m-2)-(er(mr)+er(mr-1))/2.0D+0)
      endif
      rT(mr+1)=Tesp ! temperature of space

      return
      end
