c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine sum_ACDEF(Nb,Tcentre)
      implicit none

      include 'max.inc'
      include 'data.inc'
      include 'dksi_dTg.inc'
      include 'ACDEF.inc'

      integer i,j,p,band,Nb
      double precision nbw(1:Nbmx),lambda
      double precision Planck,dBdT
      double precision Bi_ref,Bj_ref
      double precision dBdTi_ref,dBdTj_ref
      double precision Tcentre(0:Nmax+1)
c     les matrices A_ref, C_ref, D_ref, E_ref et F_ref sont les matrices de
c     sensibilits A, C, D, E et F (cf. papier), sommes sur tout le spectre

      do band=1,Nb
         nbw(band)=1.0D+4/lambda_lo(band)-1.0D+4/lambda_hi(band)
      enddo                     ! band

      do p=0,m+1

         do i=0,m+1
            do j=0,m+1
               A_ref(i,j,p)=0.0D+0
               C_ref(i,j,p)=0.0D+0
               D_ref(i,j,p)=0.0D+0
               E_ref(i,j,p)=0.0D+0
            enddo               ! j
            F_ref(i,1,p)=0.0D+0
            F_ref(i,2,p)=0.0D+0
         enddo                  ! i

         do band=1,Nb
            lambda=(lambda_lo(band)+lambda_hi(band))/2.0D+0
            do i=0,m+1
               Bi_ref=Planck(Tcentre(i),lambda_lo(band),
     &              lambda_hi(band)) ! W/m/sr/m
               dBdTi_ref=dBdT(Tcentre(i),lambda) ! W/m/sr/m/K
               do j=0,m+1
                  Bj_ref=Planck(Tcentre(j),lambda_lo(band),
     &                 lambda_hi(band)) ! W/m/sr/m
                  dBdTj_ref=dBdT(Tcentre(j),lambda) ! W/m/sr/m/K
                  A_ref(i,j,p)=A_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*Bi_ref)*nbw(band) ! W/m/K
                  D_ref(i,j,p)=D_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*Bj_ref*nbw(band)) ! W/m/K
                  C_ref(i,j,p)=C_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*dBdTi_ref*nbw(band)) ! W/m/K
                  E_ref(i,j,p)=E_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*dBdTj_ref*nbw(band)) ! W/m/K

                  if (j.eq.i-1) then ! F(i,i-1,p)
                     F_ref(i,1,p)=F_ref(i,1,p)+
     &                    0.5D+0*dksi_dTg(i,i-1,p,band)*
     &                    (dBdTi_ref+dBdTj_ref)*
     &                    nbw(band)      ! W/m/K
                  else if (j.eq.i+1) then ! F(i,i+1,p)
                     F_ref(i,2,p)=F_ref(i,2,p)+
     &                    0.5D+0*dksi_dTg(i,i+1,p,band)*
     &                    (dBdTi_ref+dBdTj_ref)*
     &                    nbw(band)      ! W/m/K
                  endif

               enddo            ! j
            enddo               ! i
         enddo ! band
      enddo ! p

      return
      end
